#!/usr/bin/perl -w

# LSB Test Execution Framework
# Index Page Module (index.pl)
#
# Copyright (C) 2007 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Net::FTP;
use Templates;

autoflush_on();

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("Upload Results to the Linux Foundation", "upload");

if ($_POST{"send_data"}) {
	# Perform data transfer
	my $result_text = "";
	my $res_dir = "";
	if ($_GET{"details"}) {
		$res_dir = $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"};
	}
	elsif ($_POST{"details"}) {
		$res_dir = $CONFIG{"RESULTS_DIR"}."/".$_POST{"details"};
		$_GET{"details"} = $_POST{"details"};
	}
	if (($res_dir ne "") and ($_POST{"upload_file"})) {
		print <<DATA;
<div id="progress_info">
<font color="green"><b>Please, wait while the file is being uploaded...</b></font><br />
Time elapsed: <span id="timer" style="font-family: monospace; color: blue;">00:00</span></p>
</div>

<script language="javascript" type="text/javascript">
// <![CDATA[
var elapsed_time = 0;
var finished = 0;
function update_timer() {
	++elapsed_time;
	var elem = document.getElementById("timer");
	if (elem && !finished) {
		var m = Math.floor(elapsed_time / 60);
		var s = elapsed_time - m * 60;
		var tmp = "";
		tmp += (m < 10) ? "0" + m : m;
		tmp += ":";
		tmp += (s < 10) ? "0" + s : s;
		elem.innerHTML = tmp;
		setTimeout("update_timer()", 1000);
	}
}

setTimeout("update_timer()", 1000);
// ]]>
</script>
DATA
		if (open(INFO_FILE, ">$res_dir/APP_INFO")) {
			print INFO_FILE "Contact name: $_POST{contact_name}\n";
			print INFO_FILE "E-mail: $_POST{email}\n";
			print INFO_FILE "Application name: $_POST{app_name}\n";
			print INFO_FILE "Application version: $_POST{app_version}\n";
			print INFO_FILE "Application homepage: $_POST{homepage}\n";
			print INFO_FILE "Comments:\n";
			print INFO_FILE $_POST{"comments"};
			close(INFO_FILE);
		}
		my $tarball_name = "$_POST{app_name}";
		$tarball_name .= "_$_POST{app_version}" if ($_POST{app_version});
		$tarball_name .= "_upload_data_";
		my $timestamp = $_GET{"details"};
		$timestamp =~ s/^.*-(\d{4})-(\d{2})-(\d{2})-(\d{2})h-(\d{2})m-(\d{2})s$/$1$2$3$4$5$6/;
		$tarball_name .= $timestamp;
		system("cd $res_dir; tar czf /tmp/$tarball_name.tar.gz ".$_POST{"upload_file"}." APP_INFO");
		if (!$?) {
			my $ftp = Net::FTP->new("ftp.linux-foundation.org", Passive => 1);
			if ($ftp) {
				if ($ftp->login("lsbatkm", "lsbatkm1")) {
					$ftp->binary();
					if ($ftp->put("/tmp/$tarball_name.tar.gz")) {
						$result_text = "<b><font color=\"green\">Uploading finished successfully!</font></b><br />You will be notified by E-mail when the application is added to the LSB Navigator database.";
						system("echo \"1\" >$res_dir/test_logs/ftp_upload");
					}
					else {
						$result_text = "<b><font color=\"red\">FTP upload failed!</font><br />".$ftp->message."</b>";
					}
				}
				else {
					$result_text = "<b><font color=\"red\">FTP login failed!</font><br />".$ftp->message."</b>";
				}
				$ftp->quit();
			}
			else {
				$result_text = "<b><font color=\"red\">FTP connection failed!</font></b>";
			}
			unlink("/tmp/$tarball_name.tar.gz");
		}
		else {
			$result_text = "<b><font color=\"red\">Error while creating tar.gz!</font></b>";
		}
		print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
finished=1;
var elem_progress_info = document.getElementById("progress_info");
if (elem_progress_info)
	elem_progress_info.style.display = 'none';
// ]]>
</script>
DATA
	}
	else {
		$result_text = "<b><font color=\"red\">The test run data to be send are not specified!</font></b>";
	}
	print "<h1>Upload Data to the Linux Foundation</h1>\n$result_text\n<br /><br /><a href=\"tests_results.pl?details=$_GET{details}\">Back to the test results page</a><br /><a href=\"tests_results.pl?details=$_GET{details}&amp;analysis=1\">Back to the analysis results page</a>";
}
elsif ($_GET{"details"}) {
	# Show the upload form
	my $app_name = "";
	my $res_dir = $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"};
	if (open(FILE, "$res_dir/INFO")) {
		while (<FILE>) {
			if (m/Application: (.*)$/) {
				$app_name = $1;
				last;
			}
		}
		close(FILE);
	}
	my $host_platform = `cat $res_dir/test_logs/host_platform`;
	my $lsb_version = `cat $res_dir/test_logs/lsb_version`;
	$host_platform =~ s/[\r\n]//g;
	$lsb_version =~ s/[\r\n]//g;

	my $warning = "";
	if (-f "$res_dir/test_logs/ftp_upload") {
		$warning = "<font color=\"red\">You have already uploaded results of this analysis. Thank you!</font><br />";
	}

	print <<DATA;
<h1>Upload Data to the Linux Foundation</h1>

$warning
<form method="post" action="upload_data.pl" name="upload_form">
<input type="hidden" name="details" value="$_GET{details}" />
<input type="hidden" name="upload_file" value="${app_name}_${host_platform}_upload_data" />
<div style="width: 600px;">
<table border="0" cellpadding="2" cellspacing="2" width="100%">
  <tr><td style="white-space: nowrap;">Contact name: <font color="red">*</font></td><td width="100%"><input type="text" name="contact_name" id="contact_name" value="" style="width: 100%;" onfocus="javascript:style.borderColor='';" /></td></tr>
  <tr><td style="white-space: nowrap;">E-mail: <font color="red">*</font></td><td><input type="text" name="email" id="email" value="" style="width: 100%;" onfocus="javascript:style.borderColor='';" /></td></tr>
  <tr><td style="white-space: nowrap;">Application name: <font color="red">*</font></td><td><input type="text" name="app_name" id="app_name" value="$app_name" style="width: 100%;" onfocus="javascript:style.borderColor='';" /></td></tr>
  <tr><td style="white-space: nowrap;">Application version:</td><td><input type="text" name="app_version" id="app_version" value="" style="width: 100%;" /></td></tr>
  <tr><td style="white-space: nowrap;">Application homepage:</td><td><input type="text" name="homepage" id="homepage" value="" style="width: 100%;" /></td></tr>
  <tr><td valign="top" style="white-space: nowrap;">Comments:</td><td><textarea name="comments" id="comments" rows="5" cols="58" style="width: 100%;"></textarea></td></tr>
</table>
<p align="center"><a href="/get.pl$res_dir/${app_name}_${host_platform}_upload_data" target="_blank">View the file to be sent</a><br /><br />
<input type="submit" name="send_data" value="Submit Data" style="width: 100px;" onclick="javascript:return check_form();" /></p>
</div>
</form>

<script language="javascript" type="text/javascript">
// <![CDATA[
function check_form() {
	var fields = new Array("contact_name", "email", "app_name");
	var field_names = new Array("Contact name", "E-mail", "Application name");
	var fails = "";
	var fails_present = false;
	for (var i=0; i<fields.length; ++i) {
		var elem = document.getElementById(fields[i]);
		if (elem) {
			if (elem.value == "") {
				elem.style.borderColor = "red";
				fails += "\\n" + field_names[i];
				fails_present = true;
			}
		}
	}
	if (fails_present) {
		alert("The following fields should be filled:" + fails);
		return false;
	}
	else
		return true;
}
// ]]>
</script>

DATA
}
else {
	print "<h1>Upload Data to the Linux Foundation</h1>\n<b><font color=\"red\">The test run data to be send are not specified!</font></b>\n";
}

print_footer();
